/*******************************************************************************

Author : Mauro Laurenti
Version : 1.2
Created on Date : 4/9/2006
Last update     : 10/10/2016

CopyRight 2006-2016 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

*******************************************************************************/


#include "RTC_test.h"


int RTC_test (void) {

	unsigned char read_second_I = 0;
	unsigned char read_second_II = 0;

	LCD_clear ();
	LCD_write_message ("TIME : ");

    //Initialize the I2C bus with 20MHz XTAL at 400Kz
	RTCC_initialize (400);

    //Read the seconds
	read_second_I = RTCC_get_seconds ();

    //wait two senconds
	delay_ms (2000);

    // read seconds once again
	read_second_II = RTCC_get_seconds ();

	if ((read_second_II - read_second_I) >=1 ) {

		LCD_clear ();
		LCD_write_message ("TIME : PASS");
		delay_ms (1500);
		return (0);

	} else {
		LCD_clear ();
		LCD_write_message ("TIME : FAIL");
		delay_ms (1500);
		return (1);
	}
}


